Attribute VB_Name = "mdlCG"
Option Explicit
'-------------------------------------------------------------------------------------------
'Author           : Paul Dahuach
'Year             : 2008
'Legal            : Do whatever you want with it, send me some feedback if you want.
'More Examples    : http://www.pauldahuach.com.ar/program_en.htm
'-------------------------------------------------------------------------------------------
' CG 2.0
Public Const CG_FALSE                                   As Long = 0&
Public Const CG_TRUE                                    As Long = 1&

Public Const CG_NO_ERROR                                As Long = 0&
Public Const CG_COMPILER_ERROR                          As Long = 1&
Public Const CG_INVALID_PARAMETER_ERROR                 As Long = 2&
Public Const CG_INVALID_PROFILE_ERROR                   As Long = 3&
Public Const CG_PROGRAM_LOAD_ERROR                      As Long = 4&
Public Const CG_PROGRAM_BIND_ERROR                      As Long = 5&
Public Const CG_PROGRAM_NOT_LOADED_ERROR                As Long = 6&
Public Const CG_UNSUPPORTED_GL_EXTENSION_ERROR          As Long = 7&
Public Const CG_INVALID_VALUE_TYPE_ERROR                As Long = 8&
Public Const CG_NOT_MATRIX_PARAM_ERROR                  As Long = 9&
Public Const CG_INVALID_ENUMERANT_ERROR                 As Long = 10&
Public Const CG_NOT_4x4_MATRIX_ERROR                    As Long = 11&
Public Const CG_FILE_READ_ERROR                         As Long = 12&
Public Const CG_FILE_WRITE_ERROR                        As Long = 13&
Public Const CG_NVPARSE_ERROR                           As Long = 14&
Public Const CG_MEMORY_ALLOC_ERROR                      As Long = 15&
Public Const CG_INVALID_CONTEXT_HANDLE_ERROR            As Long = 16&
Public Const CG_INVALID_PROGRAM_HANDLE_ERROR            As Long = 17&
Public Const CG_INVALID_PARAM_HANDLE_ERROR              As Long = 18&
Public Const CG_UNKNOWN_PROFILE_ERROR                   As Long = 19&
Public Const CG_VAR_ARG_ERROR                           As Long = 20&
Public Const CG_INVALID_DIMENSION_ERROR                 As Long = 21&
Public Const CG_ARRAY_PARAM_ERROR                       As Long = 22&
Public Const CG_OUT_OF_ARRAY_BOUNDS_ERROR               As Long = 23&
Public Const CG_CONFLICTING_TYPES_ERROR                 As Long = 24&
Public Const CG_CONFLICTING_PARAMETER_TYPES_ERROR       As Long = 25&
Public Const CG_PARAMETER_IS_NOT_SHARED_ERROR           As Long = 26&
Public Const CG_INVALID_PARAMETER_VARIABILITY_ERROR     As Long = 27&
Public Const CG_CANNOT_DESTROY_PARAMETER_ERROR          As Long = 28&
Public Const CG_NOT_ROOT_PARAMETER_ERROR                As Long = 29&
Public Const CG_PARAMETERS_DO_NOT_MATCH_ERROR           As Long = 30&
Public Const CG_IS_NOT_PROGRAM_PARAMETER_ERROR          As Long = 31&
Public Const CG_INVALID_PARAMETER_TYPE_ERROR            As Long = 32&
Public Const CG_PARAMETER_IS_NOT_RESIZABLE_ARRAY_ERROR  As Long = 33&
Public Const CG_INVALID_SIZE_ERROR                      As Long = 34&
Public Const CG_BIND_CREATES_CYCLE_ERROR                As Long = 35&
Public Const CG_ARRAY_TYPES_DO_NOT_MATCH_ERROR          As Long = 36&
Public Const CG_ARRAY_DIMENSIONS_DO_NOT_MATCH_ERROR     As Long = 37&
Public Const CG_ARRAY_HAS_WRONG_DIMENSION_ERROR         As Long = 38&
Public Const CG_TYPE_IS_NOT_DEFINED_IN_PROGRAM_ERROR    As Long = 39&
Public Const CG_INVALID_EFFECT_HANDLE_ERROR             As Long = 40&
Public Const CG_INVALID_STATE_HANDLE_ERROR              As Long = 41&
Public Const CG_INVALID_STATE_ASSIGNMENT_HANDLE_ERROR   As Long = 42&
Public Const CG_INVALID_PASS_HANDLE_ERROR               As Long = 43&
Public Const CG_INVALID_ANNOTATION_HANDLE_ERROR         As Long = 44&
Public Const CG_INVALID_TECHNIQUE_HANDLE_ERROR          As Long = 45&
Public Const CG_INVALID_PARAMETER_HANDLE_ERROR          As Long = 46&
Public Const CG_STATE_ASSIGNMENT_TYPE_MISMATCH_ERROR    As Long = 47&
Public Const CG_INVALID_FUNCTION_HANDLE_ERROR           As Long = 48&
Public Const CG_INVALID_TECHNIQUE_ERROR                 As Long = 49&
Public Const CG_INVALID_POINTER_ERROR                   As Long = 50&
Public Const CG_NOT_ENOUGH_DATA_ERROR                   As Long = 51&
Public Const CG_NON_NUMERIC_PARAMETER_ERROR             As Long = 52&
Public Const CG_ARRAY_SIZE_MISMATCH_ERROR               As Long = 53&
Public Const CG_CANNOT_SET_NON_UNIFORM_PARAMETER_ERROR  As Long = 54&
Public Const CG_DUPLICATE_NAME_ERROR                    As Long = 55&

Public Const CG_PARAMETERCLASS_UNKNOWN                  As Long = 0&
Public Const CG_PARAMETERCLASS_SCALAR                   As Long = 1&
Public Const CG_PARAMETERCLASS_VECTOR                   As Long = 2&
Public Const CG_PARAMETERCLASS_MATRIX                   As Long = 3&
Public Const CG_PARAMETERCLASS_STRUCT                   As Long = 4&
Public Const CG_PARAMETERCLASS_ARRAY                    As Long = 5&
Public Const CG_PARAMETERCLASS_SAMPLER                  As Long = 6&
Public Const CG_PARAMETERCLASS_OBJECT                   As Long = 7&

Public Const CG_UNKNOWN_DOMAIN                          As Long = 0&
Public Const CG_FIRST_DOMAIN                            As Long = 1&
Public Const CG_VERTEX_DOMAIN                           As Long = 1&
Public Const CG_FRAGMENT_DOMAIN                         As Long = 2&
Public Const CG_GEOMETRY_DOMAIN                         As Long = 3&
Public Const CG_NUMBER_OF_DOMAINS                       As Long = 4&

Public Const CG_MAP_READ                                As Long = 0&
Public Const CG_MAP_WRITE                               As Long = 1&
Public Const CG_MAP_READ_WRITE                          As Long = 2&
Public Const CG_MAP_WRITE_DISCARD                       As Long = 3&
Public Const CG_MAP_WRITE_NO_OVERWRITE                  As Long = 4&

Public Const CG_BUFFER_USAGE_STREAM_DRAW                As Long = 0&
Public Const CG_BUFFER_USAGE_STREAM_READ                As Long = 1&
Public Const CG_BUFFER_USAGE_STREAM_COPY                As Long = 2&
Public Const CG_BUFFER_USAGE_STATIC_DRAW                As Long = 3&
Public Const CG_BUFFER_USAGE_STATIC_READ                As Long = 4&
Public Const CG_BUFFER_USAGE_STATIC_COPY                As Long = 5&
Public Const CG_BUFFER_USAGE_DYNAMIC_DRAW               As Long = 6&
Public Const CG_BUFFER_USAGE_DYNAMIC_READ               As Long = 7&
Public Const CG_BUFFER_USAGE_DYNAMIC_COPY               As Long = 8&

Public Const CG_GL_MATRIX_IDENTITY                      As Long = 0&
Public Const CG_GL_MATRIX_TRANSPOSE                     As Long = 1&
Public Const CG_GL_MATRIX_INVERSE                       As Long = 2&
Public Const CG_GL_MATRIX_INVERSE_TRANSPOSE             As Long = 3&
Public Const CG_GL_MODELVIEW_MATRIX                     As Long = 4&
Public Const CG_GL_PROJECTION_MATRIX                    As Long = 5&
Public Const CG_GL_TEXTURE_MATRIX                       As Long = 6&
Public Const CG_GL_MODELVIEW_PROJECTION_MATRIX          As Long = 7&
Public Const CG_GL_VERTEX                               As Long = 8&
Public Const CG_GL_FRAGMENT                             As Long = 9&
Public Const CG_GL_GEOMETRY                             As Long = 10&

Public Const CG_UNKNOWN                                 As Long = 4096&
Public Const CG_IN                                      As Long = 4097&
Public Const CG_OUT                                     As Long = 4098&
Public Const CG_INOUT                                   As Long = 4099&
Public Const CG_MIXED                                   As Long = 4100&
Public Const CG_VARYING                                 As Long = 4101&
Public Const CG_UNIFORM                                 As Long = 4102&
Public Const CG_CONSTANT                                As Long = 4103&
Public Const CG_PROGRAM_SOURCE                          As Long = 4104&
Public Const CG_PROGRAM_ENTRY                           As Long = 4105&
Public Const CG_COMPILED_PROGRAM                        As Long = 4106&
Public Const CG_PROGRAM_PROFILE                         As Long = 4107&
Public Const CG_GLOBAL                                  As Long = 4108&
Public Const CG_PROGRAM                                 As Long = 4109&
Public Const CG_DEFAULT                                 As Long = 4110&
Public Const CG_ERROR                                   As Long = 4111&
Public Const CG_SOURCE                                  As Long = 4112&
Public Const CG_OBJECT                                  As Long = 4113&
Public Const CG_COMPILE_MANUAL                          As Long = 4114&
Public Const CG_COMPILE_IMMEDIATE                       As Long = 4115&
Public Const CG_COMPILE_LAZY                            As Long = 4116&
Public Const CG_CURRENT                                 As Long = 4117&
Public Const CG_LITERAL                                 As Long = 4118&
Public Const CG_VERSION                                 As Long = 4119&
Public Const CG_ROW_MAJOR                               As Long = 4120&
Public Const CG_COLUMN_MAJOR                            As Long = 4121&
Public Const CG_FRAGMENT                                As Long = 4122
Public Const CG_VERTEX                                  As Long = 4123
Public Const CG_POINT                                   As Long = 4124
Public Const CG_LINE                                    As Long = 4125
Public Const CG_LINE_ADJ                                As Long = 4126
Public Const CG_TRIANGLE                                As Long = 4127
Public Const CG_TRIANGLE_ADJ                            As Long = 4128
Public Const CG_POINT_OUT                               As Long = 4129
Public Const CG_LINE_OUT                                As Long = 4130
Public Const CG_TRIANGLE_OUT                            As Long = 4131
Public Const CG_IMMEDIATE_PARAMETER_SETTING             As Long = 4132
Public Const CG_DEFERRED_PARAMETER_SETTING              As Long = 4133
Public Const CG_NO_LOCKS_POLICY                         As Long = 4134
Public Const CG_THREAD_SAFE_POLICY                      As Long = 4135
Public Const CG_FORCE_UPPER_CASE_POLICY                 As Long = 4136
Public Const CG_UNCHANGED_CASE_POLICY                   As Long = 4137
 
Public Const CG_PROFILE_START                           As Long = 6144&
Public Const CG_PROFILE_UNKNOWN                         As Long = 6145&
Public Const CG_PROFILE_VP20                            As Long = 6146&
Public Const CG_PROFILE_FP20                            As Long = 6147&
Public Const CG_PROFILE_VP30                            As Long = 6148&
Public Const CG_PROFILE_FP30                            As Long = 6149&
Public Const CG_PROFILE_ARBVP1                          As Long = 6150&
Public Const CG_PROFILE_FP40                            As Long = 6151&
Public Const CG_PROFILE_ARBFP1                          As Long = 7000&
Public Const CG_PROFILE_VP40                            As Long = 7001&
Public Const CG_PROFILE_GLSLV                           As Long = 7007&
Public Const CG_PROFILE_GLSLF                           As Long = 7008&
Public Const CG_PROFILE_GLSLC                           As Long = 7009&
Public Const CG_PROFILE_GPU_FP                          As Long = 7010&
Public Const CG_PROFILE_GPU_VP                          As Long = 7011&
Public Const CG_PROFILE_GPU_GP                          As Long = 7012&
Public Const CG_PROFILE_MAX                             As Long = 7100&

Public Const CG_UNKNOWN_TYPE                            As Long = 0&
Public Const CG_STRUCT                                  As Long = 1&
Public Const CG_ARRAY                                   As Long = 2&
Public Const CG_TYPE_START_ENUM                         As Long = 1024&
Public Const CG_HALF                                    As Long = 1025&
Public Const CG_HALF2                                   As Long = 1026&
Public Const CG_HALF3                                   As Long = 1027&
Public Const CG_HALF4                                   As Long = 1028&
Public Const CG_HALF1x1                                 As Long = 1029&
Public Const CG_HALF1x2                                 As Long = 1030&
Public Const CG_HALF1x3                                 As Long = 1031&
Public Const CG_HALF1x4                                 As Long = 1032&
Public Const CG_HALF2x1                                 As Long = 1033&
Public Const CG_HALF2x2                                 As Long = 1034&
Public Const CG_HALF2x3                                 As Long = 1035&
Public Const CG_HALF2x4                                 As Long = 1036&
Public Const CG_HALF3x1                                 As Long = 1037&
Public Const CG_HALF3x2                                 As Long = 1038&
Public Const CG_HALF3x3                                 As Long = 1039&
Public Const CG_HALF3x4                                 As Long = 1040&
Public Const CG_HALF4x1                                 As Long = 1041&
Public Const CG_HALF4x2                                 As Long = 1042&
Public Const CG_HALF4x3                                 As Long = 1043&
Public Const CG_HALF4x4                                 As Long = 1044&
Public Const CG_FLOAT                                   As Long = 1045&
Public Const CG_FLOAT2                                  As Long = 1046&
Public Const CG_FLOAT3                                  As Long = 1047&
Public Const CG_FLOAT4                                  As Long = 1048&
Public Const CG_FLOAT1x1                                As Long = 1049&
Public Const CG_FLOAT1x2                                As Long = 1050&
Public Const CG_FLOAT1x3                                As Long = 1051&
Public Const CG_FLOAT1x4                                As Long = 1052&
Public Const CG_FLOAT2x1                                As Long = 1053&
Public Const CG_FLOAT2x2                                As Long = 1054&
Public Const CG_FLOAT2x3                                As Long = 1055&
Public Const CG_FLOAT2x4                                As Long = 1056&
Public Const CG_FLOAT3x1                                As Long = 1057&
Public Const CG_FLOAT3x2                                As Long = 1058&
Public Const CG_FLOAT3x3                                As Long = 1059&
Public Const CG_FLOAT3x4                                As Long = 1060&
Public Const CG_FLOAT4x1                                As Long = 1061&
Public Const CG_FLOAT4x2                                As Long = 1062&
Public Const CG_FLOAT4x3                                As Long = 1063&
Public Const CG_FLOAT4x4                                As Long = 1064&
Public Const CG_SAMPLER1D                               As Long = 1065&
Public Const CG_SAMPLER2D                               As Long = 1066&
Public Const CG_SAMPLER3D                               As Long = 1067&
Public Const CG_SAMPLERRECT                             As Long = 1068&
Public Const CG_SAMPLERCUBE                             As Long = 1069&
Public Const CG_FIXED                                   As Long = 1070&
Public Const CG_FIXED2                                  As Long = 1071&
Public Const CG_FIXED3                                  As Long = 1072&
Public Const CG_FIXED4                                  As Long = 1073&
Public Const CG_FIXED1x1                                As Long = 1074&
Public Const CG_FIXED1x2                                As Long = 1075&
Public Const CG_FIXED1x3                                As Long = 1076&
Public Const CG_FIXED1x4                                As Long = 1077&
Public Const CG_FIXED2x1                                As Long = 1078&
Public Const CG_FIXED2x2                                As Long = 1079&
Public Const CG_FIXED2x3                                As Long = 1080&
Public Const CG_FIXED2x4                                As Long = 1081&
Public Const CG_FIXED3x1                                As Long = 1082&
Public Const CG_FIXED3x2                                As Long = 1083&
Public Const CG_FIXED3x3                                As Long = 1084&
Public Const CG_FIXED3x4                                As Long = 1085&
Public Const CG_FIXED4x1                                As Long = 1086&
Public Const CG_FIXED4x2                                As Long = 1087&
Public Const CG_FIXED4x3                                As Long = 1088&
Public Const CG_FIXED4x4                                As Long = 1089&
Public Const CG_HALF1                                   As Long = 1090&
Public Const CG_FLOAT1                                  As Long = 1091&
Public Const CG_FIXED1                                  As Long = 1092&
Public Const CG_INT                                     As Long = 1093&
Public Const CG_INT1                                    As Long = 1094&
Public Const CG_INT2                                    As Long = 1095&
Public Const CG_INT3                                    As Long = 1096&
Public Const CG_INT4                                    As Long = 1097&
Public Const CG_INT1x1                                  As Long = 1098&
Public Const CG_INT1x2                                  As Long = 1099&
Public Const CG_INT1x3                                  As Long = 1100&
Public Const CG_INT1x4                                  As Long = 1101&
Public Const CG_INT2x1                                  As Long = 1102&
Public Const CG_INT2x2                                  As Long = 1103&
Public Const CG_INT2x3                                  As Long = 1104&
Public Const CG_INT2x4                                  As Long = 1105&
Public Const CG_INT3x1                                  As Long = 1106&
Public Const CG_INT3x2                                  As Long = 1107&
Public Const CG_INT3x3                                  As Long = 1108&
Public Const CG_INT3x4                                  As Long = 1109&
Public Const CG_INT4x1                                  As Long = 1110&
Public Const CG_INT4x2                                  As Long = 1111&
Public Const CG_INT4x3                                  As Long = 1112&
Public Const CG_INT4x4                                  As Long = 1113&
Public Const CG_BOOL                                    As Long = 1114&
Public Const CG_BOOL1                                   As Long = 1115&
Public Const CG_BOOL2                                   As Long = 1116&
Public Const CG_BOOL3                                   As Long = 1117&
Public Const CG_BOOL4                                   As Long = 1118&
Public Const CG_BOOL1x1                                 As Long = 1119&
Public Const CG_BOOL1x2                                 As Long = 1120&
Public Const CG_BOOL1x3                                 As Long = 1121&
Public Const CG_BOOL1x4                                 As Long = 1122&
Public Const CG_BOOL2x1                                 As Long = 1123&
Public Const CG_BOOL2x2                                 As Long = 1124&
Public Const CG_BOOL2x3                                 As Long = 1125&
Public Const CG_BOOL2x4                                 As Long = 1126&
Public Const CG_BOOL3x1                                 As Long = 1127&
Public Const CG_BOOL3x2                                 As Long = 1128&
Public Const CG_BOOL3x3                                 As Long = 1129&
Public Const CG_BOOL3x4                                 As Long = 1130&
Public Const CG_BOOL4x1                                 As Long = 1131&
Public Const CG_BOOL4x2                                 As Long = 1132&
Public Const CG_BOOL4x3                                 As Long = 1133&
Public Const CG_BOOL4x4                                 As Long = 1134&
Public Const CG_STRING                                  As Long = 1135&
Public Const CG_PROGRAM_TYPE                            As Long = 1136&
Public Const CG_TEXTURE                                 As Long = 1137&
Public Const CG_SAMPLER1DARRAY                          As Long = 1138&
Public Const CG_SAMPLER2DARRAY                          As Long = 1139&
Public Const CG_SAMPLERCUBEARRAY                        As Long = 1140&
Public Const CG_VERTEXSHADER_TYPE                       As Long = 1141&
Public Const CG_PIXELSHADER_TYPE                        As Long = 1142&
Public Const CG_SAMPLER                                 As Long = 1143&

' Library policy functions
Public Declare Function cgSetLockingPolicy Lib "vbCg20.dll" Alias "vb6_cgSetLockingPolicy" (ByVal lockingPolicy As Long) As Long
Public Declare Function cgGetLockingPolicy Lib "vbCg20.dll" Alias "vb6_cgGetLockingPolicy" () As Long
Public Declare Function cgSetSemanticCasePolicy Lib "vbCg20.dll" Alias "vb6_cgSetSemanticCasePolicy" (ByVal casePolicy As Long) As Long
Public Declare Function cgGetSemanticCasePolicy Lib "vbCg20.dll" Alias "vb6_cgGetSemanticCasePolicy" () As Long

' Context functions
Public Declare Function cgCreateContext Lib "vbCg20.dll" Alias "vb6_cgCreateContext" () As Long
Public Declare Sub cgDestroyContext Lib "vbCg20.dll" Alias "vb6_cgDestroyContext" (ByVal ctx As Long)
Public Declare Function cgIsContext Lib "vbCg20.dll" Alias "vb6_cgIsContext" (ByVal ctx As Long) As Boolean
Public Declare Function cgGetLastListing Lib "vbCg20.dll" Alias "vb6_cgGetLastListing" (ByVal ctx As Long) As Long
Public Declare Sub cgSetLastListing Lib "vbCg20.dll" Alias "vb6_cgSetLastListing" (ByVal handle As Long, ByVal listing As String)
Public Declare Sub cgSetAutoCompile Lib "vbCg20.dll" Alias "vb6_cgSetAutoCompile" (ByVal ctx As Long, ByVal flag As Long)
Public Declare Function cgGetAutoCompile Lib "vbCg20.dll" Alias "vb6_cgGetAutoCompile" (ByVal ctx As Long) As Long
Public Declare Sub cgSetParameterSettingMode Lib "vbCg20.dll" Alias "vb6_cgSetParameterSettingMode" (ByVal ctx As Long, ByVal parameterSettingMode As Long)
Public Declare Function cgGetParameterSettingMode Lib "vbCg20.dll" Alias "vb6_cgGetParameterSettingMode" (ByVal ctx As Long)

' Program functions
Public Declare Function cgCreateProgram Lib "vbCg20.dll" Alias "vb6_cgCreateProgram" (ByVal ctx As Long, ByVal program_type As Long, ByVal program As String, ByVal profile As Long, ByVal entry As String, ByVal args As String) As Long
Public Declare Function cgCreateProgramFromFile Lib "vbCg20.dll" Alias "vb6_cgCreateProgramFromFile" (ByVal ctx As Long, ByVal program_type As Long, ByVal program_file As String, ByVal profile As Long, ByVal entry As String, ByVal args As String) As Long
Public Declare Function cgCopyProgram Lib "vbCg20.dll" Alias "vb6_cgCopyProgram" (ByVal program As Long) As Long
Public Declare Sub cgDestroyProgram Lib "vbCg20.dll" Alias "vb6_cgDestroyProgram" (ByVal program As Long)
Public Declare Function cgGetFirstProgram Lib "vbCg20.dll" Alias "vb6_cgGetFirstProgram" (ByVal ctx As Long) As Long
Public Declare Function cgGetNextProgram Lib "vbCg20.dll" Alias "vb6_cgGetNextProgram" (ByVal current As Long) As Long
Public Declare Function cgGetProgramContext Lib "vbCg20.dll" Alias "vb6_cgGetProgramContext" (ByVal prog As Long) As Long
Public Declare Function cgIsProgram Lib "vbCg20.dll" Alias "vb6_cgIsProgram" (ByVal program As Long) As Boolean
Public Declare Sub cgCompileProgram Lib "vbCg20.dll" Alias "vb6_cgCompileProgram" (ByVal program As Long)
Public Declare Function cgIsProgramCompiled Lib "vbCg20.dll" Alias "vb6_cgIsProgramCompiled" (ByVal program As Long) As Boolean
Public Declare Function cgGetProgramString Lib "vbCg20.dll" Alias "vb6_cgGetProgramString" (ByVal prog As Long, ByVal pname As Long) As Long
Public Declare Function cgGetProgramProfile Lib "vbCg20.dll" Alias "vb6_cgGetProgramProfile" (ByVal prog As Long) As Long
Public Declare Function cgGetProgramOptions Lib "vbCg20.dll" Alias "vb6_cgGetProgramOptions" (ByVal prog As Long) As Long
Public Declare Sub cgSetProgramProfile Lib "vbCg20.dll" Alias "vb6_cgSetProgramProfile" (ByVal prog As Long, ByVal profile As Long)
Public Declare Function cgGetProgramInput Lib "vbCg20.dll" Alias "vb6_cgGetProgramInput" (ByVal program As Long) As Long
Public Declare Function cgGetProgramOutput Lib "vbCg20.dll" Alias "vb6_cgGetProgramOutput" (ByVal program As Long) As Long
Public Declare Sub cgSetPassProgramParameters Lib "vbCg20.dll" Alias "vb6_cgSetPassProgramParameters" (ByVal prog As Long)
Public Declare Sub cgUpdateProgramParameters Lib "vbCg20.dll" Alias "vb6_cgUpdateProgramParameters" (ByVal program As Long)

' Parameter functions
Public Declare Function cgCreateParameter Lib "vbCg20.dll" Alias "vb6_cgCreateParameter" (ByVal ctx As Long, ByVal t As Long) As Long
Public Declare Function cgCreateParameterArray Lib "vbCg20.dll" Alias "vb6_cgCreateParameterArray" (ByVal ctx As Long, ByVal t As Long, ByVal length As Long) As Long
Public Declare Function cgCreateParameterMultiDimArray Lib "vbCg20.dll" Alias "vb6_cgCreateParameterMultiDimArray" (ByVal ctx As Long, ByVal t As Long, ByVal dimension As Long, ByVal lengths As Long) As Long
Public Declare Sub cgDestroyParameter Lib "vbCg20.dll" Alias "vb6_cgDestroyParameter" (ByVal param As Long)
Public Declare Sub cgConnectParameter Lib "vbCg20.dll" Alias "vb6_cgConnectParameter" (ByVal pfrom As Long, ByVal pto As Long)
Public Declare Sub cgDisconnectParameter Lib "vbCg20.dll" Alias "vb6_cgDisconnectParameter" (ByVal param As Long)
Public Declare Function cgGetConnectedParameter Lib "vbCg20.dll" Alias "vb6_cgGetConnectedParameter" (ByVal param As Long) As Long
Public Declare Function cgGetNumConnectedToParameters Lib "vbCg20.dll" Alias "vb6_cgGetNumConnectedToParameters" (ByVal param As Long) As Long
Public Declare Function cgGetConnectedToParameter Lib "vbCg20.dll" Alias "vb6_cgGetConnectedToParameter" (ByVal param As Long, ByVal index As Long) As Long
Public Declare Function cgGetNamedParameter Lib "vbCg20.dll" Alias "vb6_cgGetNamedParameter" (ByVal prog As Long, ByVal name As String) As Long
Public Declare Function cgGetNamedProgramParameter Lib "vbCg20.dll" Alias "vb6_cgGetNamedProgramParameter" (ByVal prog As Long, ByVal name_space As Long, ByVal name As String) As Long
Public Declare Function cgGetFirstParameter Lib "vbCg20.dll" Alias "vb6_cgGetFirstParameter" (ByVal prog As Long, ByVal name_space As Long) As Long
Public Declare Function cgGetNextParameter Lib "vbCg20.dll" Alias "vb6_cgGetNextParameter" (ByVal current As Long) As Long
Public Declare Function cgGetFirstLeafParameter Lib "vbCg20.dll" Alias "vb6_cgGetFirstLeafParameter" (ByVal prog As Long, ByVal name_space As Long) As Long
Public Declare Function cgGetNextLeafParameter Lib "vbCg20.dll" Alias "vb6_cgGetNextLeafParameter" (ByVal current As Long) As Long
Public Declare Function cgGetFirstStructParameter Lib "vbCg20.dll" Alias "vb6_cgGetFirstStructParameter" (ByVal param As Long) As Long
Public Declare Function cgGetNamedStructParameter Lib "vbCg20.dll" Alias "vb6_cgGetNamedStructParameter" (ByVal param As Long, ByVal name As String) As Long
Public Declare Function cgGetFirstDependentParameter Lib "vbCg20.dll" Alias "vb6_cgGetFirstDependentParameter" (ByVal param As Long) As Long
Public Declare Function cgGetArrayParameter Lib "vbCg20.dll" Alias "vb6_cgGetArrayParameter" (ByVal aparam As Long, ByVal index As Long) As Long
Public Declare Function cgGetArrayDimension Lib "vbCg20.dll" Alias "vb6_cgGetArrayDimension" (ByVal param As Long) As Long
Public Declare Function cgGetArrayType Lib "vbCg20.dll" Alias "vb6_cgGetArrayType" (ByVal param As Long) As Long
Public Declare Function cgGetArraySize Lib "vbCg20.dll" Alias "vb6_cgGetArraySize" (ByVal param As Long, ByVal dimension As Long) As Long
Public Declare Function cgGetArrayTotalSize Lib "vbCg20.dll" Alias "vb6_cgGetArrayTotalSize" (ByVal param As Long) As Long
Public Declare Sub cgSetArraySize Lib "vbCg20.dll" Alias "vb6_cgSetArraySize" (ByVal param As Long, ByVal size As Long)
Public Declare Sub cgSetMultiDimArraySize Lib "vbCg20.dll" Alias "vb6_cgSetMultiDimArraySize" (ByVal param As Long, sizes As Long)
Public Declare Function cgGetParameterProgram Lib "vbCg20.dll" Alias "vb6_cgGetParameterProgram" (ByVal param As Long) As Long
Public Declare Function cgGetParameterContext Lib "vbCg20.dll" Alias "vb6_cgGetParameterContext" (ByVal param As Long) As Long
Public Declare Function cgIsParameter Lib "vbCg20.dll" Alias "vb6_cgIsParameter" (ByVal param As Long) As Long
Public Declare Function cgGetParameterName Lib "vbCg20.dll" Alias "vb6_cgGetParameterName" (ByVal param As Long) As Long
Public Declare Function cgGetParameterType Lib "vbCg20.dll" Alias "vb6_cgGetParameterType" (ByVal param As Long) As Long
Public Declare Function cgGetParameterBaseType Lib "vbCg20.dll" Alias "vb6_cgGetParameterBaseType" (ByVal param As Long) As Long
Public Declare Function cgGetParameterClass Lib "vbCg20.dll" Alias "vb6_cgGetParameterClass" (ByVal param As Long) As Long
Public Declare Function cgGetParameterRows Lib "vbCg20.dll" Alias "vb6_cgGetParameterRows" (ByVal param As Long) As Long
Public Declare Function cgGetParameterColumns Lib "vbCg20.dll" Alias "vb6_cgGetParameterColumns" (ByVal param As Long) As Long
Public Declare Function cgGetParameterNamedType Lib "vbCg20.dll" Alias "vb6_cgGetParameterNamedType" (ByVal param As Long) As Long
Public Declare Function cgGetParameterSemantic Lib "vbCg20.dll" Alias "vb6_cgGetParameterSemantic" (ByVal param As Long) As Long
Public Declare Function cgGetParameterResource Lib "vbCg20.dll" Alias "vb6_cgGetParameterResource" (ByVal param As Long) As Long
Public Declare Function cgGetParameterBaseResource Lib "vbCg20.dll" Alias "vb6_cgGetParameterBaseResource" (ByVal param As Long) As Long
Public Declare Function cgGetParameterResourceIndex Lib "vbCg20.dll" Alias "vb6_cgGetParameterResourceIndex" (ByVal param As Long) As Long
Public Declare Function cgGetParameterVariability Lib "vbCg20.dll" Alias "vb6_cgGetParameterVariability" (ByVal param As Long) As Long
Public Declare Function cgGetParameterDirection Lib "vbCg20.dll" Alias "vb6_cgGetParameterDirection" (ByVal param As Long) As Long
Public Declare Function cgIsParameterReferenced Lib "vbCg20.dll" Alias "vb6_cgIsParameterReferenced" (ByVal param As Long) As Long
Public Declare Function cgIsParameterUsed Lib "vbCg20.dll" Alias "vb6_cgIsParameterUsed" (ByVal param As Long, ByVal handle As Long) As Long
Public Declare Function cgGetParameterValues Lib "vbCg20.dll" Alias "vb6_cgGetParameterValues" (ByVal param As Long, ByVal value_type As Long, nvalues As Long) As Long
Public Declare Sub cgSetParameterValuedr Lib "vbCg20.dll" Alias "vb6_cgSetParameterValuedr" (ByVal param As Long, ByVal n As Long, vals As Double)
Public Declare Sub cgSetParameterValuedc Lib "vbCg20.dll" Alias "vb6_cgSetParameterValuedc" (ByVal param As Long, ByVal n As Long, vals As Double)
Public Declare Sub cgSetParameterValuefr Lib "vbCg20.dll" Alias "vb6_cgSetParameterValuefr" (ByVal param As Long, ByVal n As Long, vals As Single)
Public Declare Sub cgSetParameterValuefc Lib "vbCg20.dll" Alias "vb6_cgSetParameterValuefc" (ByVal param As Long, ByVal n As Long, vals As Single)
Public Declare Sub cgSetParameterValueir Lib "vbCg20.dll" Alias "vb6_cgSetParameterValueir" (ByVal param As Long, ByVal n As Long, vals As Long)
Public Declare Sub cgSetParameterValueic Lib "vbCg20.dll" Alias "vb6_cgSetParameterValueic" (ByVal param As Long, ByVal n As Long, vals As Long)
Public Declare Function cgGetParameterValuedr Lib "vbCg20.dll" Alias "vb6_cgGetParameterValuedr" (ByVal param As Long, ByVal n As Long, vals As Double) As Long
Public Declare Function cgGetParameterValuedc Lib "vbCg20.dll" Alias "vb6_cgGetParameterValuedc" (ByVal param As Long, ByVal n As Long, vals As Double) As Long
Public Declare Function cgGetParameterValuefr Lib "vbCg20.dll" Alias "vb6_cgGetParameterValuefr" (ByVal param As Long, ByVal n As Long, vals As Single) As Long
Public Declare Function cgGetParameterValuefc Lib "vbCg20.dll" Alias "vb6_cgGetParameterValuefc" (ByVal param As Long, ByVal n As Long, vals As Single) As Long
Public Declare Function cgGetParameterValueir Lib "vbCg20.dll" Alias "vb6_cgGetParameterValueir" (ByVal param As Long, ByVal n As Long, vals As Long) As Long
Public Declare Function cgGetParameterValueic Lib "vbCg20.dll" Alias "vb6_cgGetParameterValueic" (ByVal param As Long, ByVal n As Long, vals As Long) As Long
Public Declare Function cgGetStringParameterValue Lib "vbCg20.dll" Alias "vb6_cgGetStringParameterValue" (ByVal param As Long) As Long
Public Declare Sub cgSetStringParameterValue Lib "vbCg20.dll" Alias "vb6_cgSetStringParameterValue" (ByVal param As Long, ByVal charstr As String)
Public Declare Function cgGetParameterOrdinalNumber Lib "vbCg20.dll" Alias "vb6_cgGetParameterOrdinalNumber" (ByVal param As Long) As Long
Public Declare Function cgIsParameterGlobal Lib "vbCg20.dll" Alias "vb6_cgIsParameterGlobal" (ByVal param As Long) As Long
Public Declare Function cgGetParameterIndex Lib "vbCg20.dll" Alias "vb6_cgGetParameterIndex" (ByVal param As Long) As Long
Public Declare Sub cgSetParameterVariability Lib "vbCg20.dll" Alias "vb6_cgSetParameterVariability" (ByVal param As Long, ByVal vary As Long)
Public Declare Sub cgSetParameterSemantic Lib "vbCg20.dll" Alias "vb6_cgSetParameterSemantic" (ByVal param As Long, ByVal semantic As String)
Public Declare Sub cgSetParameter1f Lib "vbCg20.dll" Alias "vb6_cgSetParameter1f" (ByVal param As Long, ByVal x As Single)
Public Declare Sub cgSetParameter2f Lib "vbCg20.dll" Alias "vb6_cgSetParameter2f" (ByVal param As Long, ByVal x As Single, ByVal y As Single)
Public Declare Sub cgSetParameter3f Lib "vbCg20.dll" Alias "vb6_cgSetParameter3f" (ByVal param As Long, ByVal x As Single, ByVal y As Single, ByVal z As Single)
Public Declare Sub cgSetParameter4f Lib "vbCg20.dll" Alias "vb6_cgSetParameter4f" (ByVal param As Long, ByVal x As Single, ByVal y As Single, ByVal z As Single, ByVal w As Single)
Public Declare Sub cgSetParameter1d Lib "vbCg20.dll" Alias "vb6_cgSetParameter1d" (ByVal param As Long, ByVal x As Double)
Public Declare Sub cgSetParameter2d Lib "vbCg20.dll" Alias "vb6_cgSetParameter2d" (ByVal param As Long, ByVal x As Double, ByVal y As Double)
Public Declare Sub cgSetParameter3d Lib "vbCg20.dll" Alias "vb6_cgSetParameter3d" (ByVal param As Long, ByVal x As Double, ByVal y As Double, ByVal z As Double)
Public Declare Sub cgSetParameter4d Lib "vbCg20.dll" Alias "vb6_cgSetParameter4d" (ByVal param As Long, ByVal x As Double, ByVal y As Double, ByVal z As Double, ByVal w As Double)
Public Declare Sub cgSetParameter1i Lib "vbCg20.dll" Alias "vb6_cgSetParameter1i" (ByVal param As Long, ByVal x As Long)
Public Declare Sub cgSetParameter2i Lib "vbCg20.dll" Alias "vb6_cgSetParameter2i" (ByVal param As Long, ByVal x As Long, ByVal y As Long)
Public Declare Sub cgSetParameter3i Lib "vbCg20.dll" Alias "vb6_cgSetParameter3i" (ByVal param As Long, ByVal x As Long, ByVal y As Long, ByVal z As Long)
Public Declare Sub cgSetParameter4i Lib "vbCg20.dll" Alias "vb6_cgSetParameter4i" (ByVal param As Long, ByVal x As Long, ByVal y As Long, ByVal z As Long, ByVal w As Long)
Public Declare Sub cgSetParameter1iv Lib "vbCg20.dll" Alias "vb6_cgSetParameter1iv" (ByVal param As Long, v As Long)
Public Declare Sub cgSetParameter2iv Lib "vbCg20.dll" Alias "vb6_cgSetParameter2iv" (ByVal param As Long, v As Long)
Public Declare Sub cgSetParameter3iv Lib "vbCg20.dll" Alias "vb6_cgSetParameter3iv" (ByVal param As Long, v As Long)
Public Declare Sub cgSetParameter4iv Lib "vbCg20.dll" Alias "vb6_cgSetParameter4iv" (ByVal param As Long, v As Long)
Public Declare Sub cgSetParameter1fv Lib "vbCg20.dll" Alias "vb6_cgSetParameter1fv" (ByVal param As Long, v As Single)
Public Declare Sub cgSetParameter2fv Lib "vbCg20.dll" Alias "vb6_cgSetParameter2fv" (ByVal param As Long, v As Single)
Public Declare Sub cgSetParameter3fv Lib "vbCg20.dll" Alias "vb6_cgSetParameter3fv" (ByVal param As Long, v As Single)
Public Declare Sub cgSetParameter4fv Lib "vbCg20.dll" Alias "vb6_cgSetParameter4fv" (ByVal param As Long, v As Single)
Public Declare Sub cgSetParameter1dv Lib "vbCg20.dll" Alias "vb6_cgSetParameter1dv" (ByVal param As Long, v As Double)
Public Declare Sub cgSetParameter2dv Lib "vbCg20.dll" Alias "vb6_cgSetParameter2dv" (ByVal param As Long, v As Double)
Public Declare Sub cgSetParameter3dv Lib "vbCg20.dll" Alias "vb6_cgSetParameter3dv" (ByVal param As Long, v As Double)
Public Declare Sub cgSetParameter4dv Lib "vbCg20.dll" Alias "vb6_cgSetParameter4dv" (ByVal param As Long, v As Double)
Public Declare Sub cgSetMatrixParameterir Lib "vbCg20.dll" Alias "vb6_cgSetMatrixParameterir" (ByVal param As Long, Matrix As Long)
Public Declare Sub cgSetMatrixParameterdr Lib "vbCg20.dll" Alias "vb6_cgSetMatrixParameterdr" (ByVal param As Long, Matrix As Double)
Public Declare Sub cgSetMatrixParameterfr Lib "vbCg20.dll" Alias "vb6_cgSetMatrixParameterfr" (ByVal param As Long, Matrix As Single)
Public Declare Sub cgSetMatrixParameteric Lib "vbCg20.dll" Alias "vb6_cgSetMatrixParameteric" (ByVal param As Long, Matrix As Long)
Public Declare Sub cgSetMatrixParameterdc Lib "vbCg20.dll" Alias "vb6_cgSetMatrixParameterdc" (ByVal param As Long, Matrix As Double)
Public Declare Sub cgSetMatrixParameterfc Lib "vbCg20.dll" Alias "vb6_cgSetMatrixParameterfc" (ByVal param As Long, Matrix As Single)
Public Declare Sub cgGetMatrixParameterir Lib "vbCg20.dll" Alias "vb6_cgGetMatrixParameterir" (ByVal param As Long, Matrix As Long)
Public Declare Sub cgGetMatrixParameterdr Lib "vbCg20.dll" Alias "vb6_cgGetMatrixParameterdr" (ByVal param As Long, Matrix As Double)
Public Declare Sub cgGetMatrixParameterfr Lib "vbCg20.dll" Alias "vb6_cgGetMatrixParameterfr" (ByVal param As Long, Matrix As Single)
Public Declare Sub cgGetMatrixParameteric Lib "vbCg20.dll" Alias "vb6_cgGetMatrixParameteric" (ByVal param As Long, Matrix As Long)
Public Declare Sub cgGetMatrixParameterdc Lib "vbCg20.dll" Alias "vb6_cgGetMatrixParameterdc" (ByVal param As Long, Matrix As Double)
Public Declare Sub cgGetMatrixParameterfc Lib "vbCg20.dll" Alias "vb6_cgGetMatrixParameterfc" (ByVal param As Long, Matrix As Single)
Public Declare Function cgGetNamedSubParameter Lib "vbCg20.dll" Alias "vb6_cgGetNamedSubParameter" (ByVal param As Long, ByVal name As String) As Long

' Type Functions
Public Declare Function cgGetTypeString Lib "vbCg20.dll" Alias "vb6_cgGetTypeString" (ByVal t As Long) As Long
Public Declare Function cgGetType Lib "vbCg20.dll" Alias "vb6_cgGetType" (ByVal type_string As String) As Long
Public Declare Function cgGetNamedUserType Lib "vbCg20.dll" Alias "vb6_cgGetNamedUserType" (ByVal handle As Long, ByVal name As String) As Long
Public Declare Function cgGetNumUserTypes Lib "vbCg20.dll" Alias "vb6_cgGetNumUserTypes" (ByVal handle As Long) As Long
Public Declare Function cgGetUserType Lib "vbCg20.dll" Alias "vb6_cgGetUserType" (ByVal handle As Long, ByVal index As Long) As Long
Public Declare Function cgGetNumParentTypes Lib "vbCg20.dll" Alias "vb6_cgGetNumParentTypes" (ByVal t As Long) As Long
Public Declare Function cgGetParentType Lib "vbCg20.dll" Alias "vb6_cgGetParentType" (ByVal t As Long, ByVal index As Long) As Long
Public Declare Function cgIsParentType Lib "vbCg20.dll" Alias "vb6_cgIsParentType" (ByVal parent As Long, ByVal child As Long) As Long
Public Declare Function cgIsInterfaceType Lib "vbCg20.dll" Alias "vb6_cgIsInterfaceType" (ByVal t As Long) As Long

' Resource Functions
Public Declare Function cgGetResourceString Lib "vbCg20.dll" Alias "vb6_cgGetResourceString" (ByVal resource As Long) As Long
Public Declare Function cgGetResource Lib "vbCg20.dll" Alias "vb6_cgGetResource" (ByVal resource_string As String) As Long

' Enum Functions
Public Declare Function cgGetEnumString Lib "vbCg20.dll" Alias "vb6_cgGetEnumString" (ByVal en As Long) As Long
Public Declare Function cgGetEnum Lib "vbCg20.dll" Alias "vb6_cgGetEnum" (ByVal enum_string As String) As Long

' Profile Functions
Public Declare Function cgGetProfileString Lib "vbCg20.dll" Alias "vb6_cgGetProfileString" (ByVal profile As Long) As Long
Public Declare Function cgGetProfile Lib "vbCg20.dll" Alias "vb6_cgGetProfile" (ByVal profile_string As String) As Long

' Error Functions
Public Declare Function cgGetError Lib "vbCg20.dll" Alias "vb6_cgGetError" () As Long
Public Declare Function cgGetFirstError Lib "vbCg20.dll" Alias "vb6_cgGetFirstError" () As Long
Public Declare Function cgGetErrorString Lib "vbCg20.dll" Alias "vb6_cgGetErrorString" (ByVal error As Long) As Long
Public Declare Function cgGetLastErrorString Lib "vbCg20.dll" Alias "vb6_cgGetLastErrorString" (ByVal error As Long) As Long
Public Declare Sub cgSetErrorCallback Lib "vbCg20.dll" Alias "vb6_cgSetErrorCallback" (ByVal func As Long)
Public Declare Function cgGetErrorCallback Lib "vbCg20.dll" Alias "vb6_cgGetErrorCallback" () As Long
Public Declare Sub cgSetErrorHandler Lib "vbCg20.dll" Alias "vb6_cgSetErrorHandler" (ByVal func As Long, ByVal data As Long)
Public Declare Function cgGetErrorHandler Lib "vbCg20.dll" Alias "vb6_cgGetErrorHandler" (ByVal data As Long) As Long

' Misc Functions
Public Declare Function cgGetString Lib "vbCg20.dll" Alias "vb6_cgGetString" (ByVal sname As Long) As Long

' CgFX Functions
Public Declare Function cgCreateEffect Lib "vbCg20.dll" Alias "vb6_cgCreateEffect" (ByVal context As Long, ByVal code As String, ByVal args As Long) As Long
Public Declare Function cgCreateEffectFromFile Lib "vbCg20.dll" Alias "vb6_cgCreateEffectFromFile" (ByVal context As Long, ByVal filename As String, ByVal args As Long) As Long
Public Declare Function cgCopyEffect Lib "vbCg20.dll" Alias "vb6_cgCopyEffect" (ByVal effect As Long) As Long
Public Declare Sub cgDestroyEffect Lib "vbCg20.dll" Alias "vb6_cgDestroyEffect" (ByVal effect As Long)
Public Declare Function cgGetEffectContext Lib "vbCg20.dll" Alias "vb6_cgGetEffectContext" (ByVal effect As Long) As Long
Public Declare Function cgIsEffect Lib "vbCg20.dll" Alias "vb6_cgIsEffect" (ByVal effect As Long) As Long

Public Declare Function cgGetFirstEffect Lib "vbCg20.dll" Alias "vb6_cgGetFirstEffect" (ByVal context As Long) As Long
Public Declare Function cgGetNextEffect Lib "vbCg20.dll" Alias "vb6_cgGetNextEffect" (ByVal effect As Long) As Long

Public Declare Function cgCreateProgramFromEffect Lib "vbCg20.dll" Alias "vb6_cgCreateProgramFromEffect" (ByVal effect As Long, _
                                                     ByVal profile As Long, _
                                                     ByVal entry As String, _
                                                     ByVal args As Long) As Long

Public Declare Function cgGetFirstTechnique Lib "vbCg20.dll" Alias "vb6_cgGetFirstTechnique" (ByVal effect As Long) As Long
Public Declare Function cgGetNextTechnique Lib "vbCg20.dll" Alias "vb6_cgGetNextTechnique" (ByVal technique As Long) As Long
Public Declare Function cgGetNamedTechnique Lib "vbCg20.dll" Alias "vb6_cgGetNamedTechnique" (ByVal effect As Long, ByVal name As String) As Long
Public Declare Function cgGetTechniqueName Lib "vbCg20.dll" Alias "vb6_cgGetTechniqueName" (ByVal technique As Long) As Long
Public Declare Function cgIsTechnique Lib "vbCg20.dll" Alias "vb6_cgIsTechnique" (ByVal technique As Long) As Long
Public Declare Function cgValidateTechnique Lib "vbCg20.dll" Alias "vb6_cgValidateTechnique" (ByVal technique As Long) As Long
Public Declare Function cgIsTechniqueValidated Lib "vbCg20.dll" Alias "vb6_cgIsTechniqueValidated" (ByVal technique As Long) As Long
Public Declare Function cgGetTechniqueEffect Lib "vbCg20.dll" Alias "vb6_cgGetTechniqueEffect" (ByVal technique As Long) As Long

Public Declare Function cgGetFirstPass Lib "vbCg20.dll" Alias "vb6_cgGetFirstPass" (ByVal technique As Long) As Long
Public Declare Function cgGetNamedPass Lib "vbCg20.dll" Alias "vb6_cgGetNamedPass" (ByVal technique As Long, ByVal name As String) As Long
Public Declare Function cgGetNextPass Lib "vbCg20.dll" Alias "vb6_cgGetNextPass" (ByVal pass As Long) As Long
Public Declare Function cgIsPass Lib "vbCg20.dll" Alias "vb6_cgIsPass" (ByVal pass As Long) As Long
Public Declare Function cgGetPassName Lib "vbCg20.dll" Alias "vb6_cgGetPassName" (ByVal pass As Long) As Long
Public Declare Function cgGetPassTechnique Lib "vbCg20.dll" Alias "vb6_cgGetPassTechnique" (ByVal pass As Long) As Long

Public Declare Sub cgSetPassState Lib "vbCg20.dll" Alias "vb6_cgSetPassState" (ByVal pass As Long)
Public Declare Sub cgResetPassState Lib "vbCg20.dll" Alias "vb6_cgResetPassState" (ByVal pass As Long)

Public Declare Function cgGetFirstStateAssignment Lib "vbCg20.dll" Alias "vb6_cgGetFirstStateAssignment" (ByVal pass As Long) As Long
Public Declare Function cgGetNamedStateAssignment Lib "vbCg20.dll" Alias "vb6_cgGetNamedStateAssignment" (ByVal pass As Long, ByVal name As String) As Long
Public Declare Function cgGetNextStateAssignment Lib "vbCg20.dll" Alias "vb6_cgGetNextStateAssignment" (ByVal stateassignment As Long) As Long
Public Declare Function cgIsStateAssignment Lib "vbCg20.dll" Alias "vb6_cgIsStateAssignment" (ByVal stateassignment As Long) As Long
Public Declare Function cgCallStateSetCallback Lib "vbCg20.dll" Alias "vb6_cgCallStateSetCallback" (ByVal stateassignment As Long) As Long
Public Declare Function cgCallStateValidateCallback Lib "vbCg20.dll" Alias "vb6_cgCallStateValidateCallback" (ByVal stateassignment As Long) As Long
Public Declare Function cgCallStateResetCallback Lib "vbCg20.dll" Alias "vb6_cgCallStateResetCallback" (ByVal stateassignment As Long) As Long
Public Declare Function cgGetStateAssignmentPass Lib "vbCg20.dll" Alias "vb6_cgGetStateAssignmentPass" (ByVal stateassignment As Long) As Long
Public Declare Function cgGetSamplerStateAssignmentParameter Lib "vbCg20.dll" Alias "vb6_cgGetSamplerStateAssignmentParameter" (ByVal stateassignment As Long) As Long

Public Declare Function cgGetFloatStateAssignmentValues Lib "vbCg20.dll" Alias "vb6_cgGetFloatStateAssignmentValues" (ByVal stateassignment As Long, ByVal nVals As Long) As Long
Public Declare Function cgGetIntStateAssignmentValues Lib "vbCg20.dll" Alias "vb6_cgGetIntStateAssignmentValues" (ByVal stateassignment As Long, ByVal nVals As Long) As Long
Public Declare Function cgGetBoolStateAssignmentValues Lib "vbCg20.dll" Alias "vb6_cgGetBoolStateAssignmentValues" (ByVal stateassignment As Long, ByVal nVals As Long) As Long
Public Declare Function cgGetStringStateAssignmentValue Lib "vbCg20.dll" Alias "vb6_cgGetStringStateAssignmentValue" (ByVal stateassignment As Long) As Long
Public Declare Function cgGetProgramStateAssignmentValue Lib "vbCg20.dll" Alias "vb6_cgGetProgramStateAssignmentValue" (ByVal stateassignment As Long) As Long
Public Declare Function cgGetTextureStateAssignmentValue Lib "vbCg20.dll" Alias "vb6_cgGetTextureStateAssignmentValue" (ByVal stateassignment As Long) As Long
Public Declare Function cgGetSamplerStateAssignmentValue Lib "vbCg20.dll" Alias "vb6_cgGetSamplerStateAssignmentValue" (ByVal stateassignment As Long) As Long
Public Declare Function cgGetStateAssignmentIndex Lib "vbCg20.dll" Alias "vb6_cgGetStateAssignmentIndex" (ByVal stateassignment As Long) As Long

Public Declare Function cgGetNumDependentStateAssignmentParameters Lib "vbCg20.dll" Alias "vb6_cgGetNumDependentStateAssignmentParameters" (ByVal stateassignment As Long) As Long
Public Declare Function cgGetDependentStateAssignmentParameter Lib "vbCg20.dll" Alias "vb6_cgGetDependentStateAssignmentParameter" (ByVal stateassignment As Long, ByVal index As Long) As Long

Public Declare Function cgGetConnectedStateAssignmentParameter Lib "vbCg20.dll" Alias "vb6_cgGetConnectedStateAssignmentParameter" (ByVal stateassignment As Long) As Long

Public Declare Function cgGetStateAssignmentState Lib "vbCg20.dll" Alias "vb6_cgGetStateAssignmentState" (ByVal stateassignment As Long) As Long
Public Declare Function cgGetSamplerStateAssignmentState Lib "vbCg20.dll" Alias "vb6_cgGetSamplerStateAssignmentState" (ByVal stateassignment As Long) As Long

Public Declare Function cgCreateState Lib "vbCg20.dll" Alias "vb6_cgCreateState" (ByVal context As Long, ByVal name As String, ByVal t As Long) As Long
Public Declare Function cgCreateArrayState Lib "vbCg20.dll" Alias "vb6_cgCreateArrayState" (ByVal context As Long, ByVal name As String, ByVal t As Long, ByVal nelems As Long) As Long
Public Declare Sub cgSetStateCallbacks Lib "vbCg20.dll" Alias "vb6_cgSetStateCallbacks" (ByVal state As Long, ByVal setc As Long, ByVal reset As Long, ByVal validate As Long)
Public Declare Function cgGetStateSetCallback Lib "vbCg20.dll" Alias "vb6_cgGetStateSetCallback" (ByVal state As Long) As Long
Public Declare Function cgGetStateResetCallback Lib "vbCg20.dll" Alias "vb6_cgGetStateResetCallback" (ByVal state As Long) As Long
Public Declare Function cgGetStateValidateCallback Lib "vbCg20.dll" Alias "vb6_cgGetStateValidateCallback" (ByVal state As Long) As Long
Public Declare Function cgGetStateContext Lib "vbCg20.dll" Alias "vb6_cgGetStateContext" (ByVal state As Long) As Long
Public Declare Function cgGetStateType Lib "vbCg20.dll" Alias "vb6_cgGetStateType" (ByVal state As Long) As Long
Public Declare Function cgGetStateName Lib "vbCg20.dll" Alias "vb6_cgGetStateName" (ByVal state As Long) As Long
Public Declare Function cgGetNamedState Lib "vbCg20.dll" Alias "vb6_cgGetNamedState" (ByVal context As Long, ByVal name As String) As Long
Public Declare Function cgGetFirstState Lib "vbCg20.dll" Alias "vb6_cgGetFirstState" (ByVal context As Long) As Long
Public Declare Function cgGetNextState Lib "vbCg20.dll" Alias "vb6_cgGetNextState" (ByVal state As Long) As Long
Public Declare Function cgIsState Lib "vbCg20.dll" Alias "vb6_cgIsState" (ByVal state As Long) As Long
Public Declare Sub cgAddStateEnumerant Lib "vbCg20.dll" Alias "vb6_cgAddStateEnumerant" (ByVal state As Long, ByVal name As String, ByVal value As Long)

Public Declare Function cgCreateSamplerState Lib "vbCg20.dll" Alias "vb6_cgCreateSamplerState" (ByVal context As Long, ByVal name As String, ByVal t As Long) As Long
Public Declare Function cgCreateArraySamplerState Lib "vbCg20.dll" Alias "vb6_cgCreateArraySamplerState" (ByVal context As Long, ByVal name As String, ByVal t As Long, ByVal nelems As Long) As Long
Public Declare Function cgGetNamedSamplerState Lib "vbCg20.dll" Alias "vb6_cgGetNamedSamplerState" (ByVal context As Long, ByVal name As String) As Long
Public Declare Function cgGetFirstSamplerState Lib "vbCg20.dll" Alias "vb6_cgGetFirstSamplerState" (ByVal context As Long) As Long

Public Declare Function cgGetFirstSamplerStateAssignment Lib "vbCg20.dll" Alias "vb6_cgGetFirstSamplerStateAssignment" (ByVal parameter As Long) As Long
Public Declare Function cgGetNamedSamplerStateAssignment Lib "vbCg20.dll" Alias "vb6_cgGetNamedSamplerStateAssignment" (ByVal parameter As Long, ByVal s As String) As Long
Public Declare Sub cgSetSamplerState Lib "vbCg20.dll" Alias "vb6_cgSetSamplerState" (ByVal parameter As Long)

Public Declare Function cgGetNamedEffectParameter Lib "vbCg20.dll" Alias "vb6_cgGetNamedEffectParameter" (ByVal effect As Long, ByVal s As String) As Long
Public Declare Function cgGetFirstLeafEffectParameter Lib "vbCg20.dll" Alias "vb6_cgGetFirstLeafEffectParameter" (ByVal effect As Long) As Long
Public Declare Function cgGetFirstEffectParameter Lib "vbCg20.dll" Alias "vb6_cgGetFirstEffectParameter" (ByVal effect As Long) As Long
Public Declare Function cgGetEffectParameterBySemantic Lib "vbCg20.dll" Alias "vb6_cgGetEffectParameterBySemantic" (ByVal effect As Long, ByVal s As String) As Long

Public Declare Function cgGetFirstTechniqueAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetFirstTechniqueAnnotation" (ByVal technique As Long) As Long
Public Declare Function cgGetFirstPassAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetFirstPassAnnotation" (ByVal pass As Long) As Long
Public Declare Function cgGetFirstParameterAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetFirstParameterAnnotation" (ByVal parameter As Long) As Long
Public Declare Function cgGetFirstProgramAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetFirstProgramAnnotation" (ByVal program As Long) As Long
Public Declare Function cgGetFirstEffectAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetFirstEffectAnnotation" (ByVal effect As Long) As Long
Public Declare Function cgGetNextAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetNextAnnotation" (ByVal annotation As Long) As Long

Public Declare Function cgGetNamedTechniqueAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetNamedTechniqueAnnotation" (ByVal technique As Long, ByVal s As String) As Long
Public Declare Function cgGetNamedPassAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetNamedPassAnnotation" (ByVal pass As Long, ByVal s As String) As Long
Public Declare Function cgGetNamedParameterAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetNamedParameterAnnotation" (ByVal parameter As Long, ByVal s As String) As Long
Public Declare Function cgGetNamedProgramAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetNamedProgramAnnotation" (ByVal program As Long, ByVal s As String) As Long
Public Declare Function cgGetNamedEffectAnnotation Lib "vbCg20.dll" Alias "vb6_cgGetNamedEffectAnnotation" (ByVal effect As Long, ByVal s As String) As Long

Public Declare Function cgIsAnnotation Lib "vbCg20.dll" Alias "vb6_cgIsAnnotation" (ByVal annotation As Long) As Long

Public Declare Function cgGetAnnotationName Lib "vbCg20.dll" Alias "vb6_cgGetAnnotationName" (ByVal annotation As Long) As Long
Public Declare Function cgGetAnnotationType Lib "vbCg20.dll" Alias "vb6_cgGetAnnotationType" (ByVal annotation As Long) As Long

Public Declare Function cgGetFloatAnnotationValues Lib "vbCg20.dll" Alias "vb6_cgGetFloatAnnotationValues" (ByVal annotation As Long, ByVal nvalues As Long) As Long
Public Declare Function cgGetIntAnnotationValues Lib "vbCg20.dll" Alias "vb6_cgGetIntAnnotationValues" (ByVal annotation As Long, ByVal nvalues As Long) As Long
Public Declare Function cgGetStringAnnotationValue Lib "vbCg20.dll" Alias "vb6_cgGetStringAnnotationValue" (ByVal annotation As Long) As Long
Public Declare Function cgGetStringAnnotationValues Lib "vbCg20.dll" Alias "vb6_cgGetStringAnnotationValues" (ByVal annotation As Long, ByVal nvalues As Long) As Long
Public Declare Function cgGetBoolAnnotationValues Lib "vbCg20.dll" Alias "vb6_cgGetBoolAnnotationValues" (ByVal annotation As Long, ByVal nvalues As Long) As Long
Public Declare Function cgGetBooleanAnnotationValues Lib "vbCg20.dll" Alias "vb6_cgGetBooleanAnnotationValues" (ByVal annotation As Long, ByVal nvalues As Long) As Long

Public Declare Function cgGetNumDependentAnnotationParameters Lib "vbCg20.dll" Alias "vb6_cgGetNumDependentAnnotationParameters" (ByVal annotation As Long) As Long
Public Declare Function cgGetDependentAnnotationParameter Lib "vbCg20.dll" Alias "vb6_cgGetDependentAnnotationParameter" (ByVal annotation As Long, ByVal index As Long) As Long

Public Declare Sub cgEvaluateProgram Lib "vbCg20.dll" Alias "vb6_cgEvaluateProgram" (ByVal program As Long, ByVal f As Single, ByVal ncomps As Long, ByVal nx As Long, ByVal ny As Long, ByVal nz As Long)

' Cg 1.5 Additions
Public Declare Function cgSetEffectName Lib "vbCg20.dll" Alias "vb6_cgSetEffectName" (ByVal effect As Long, ByVal name As String) As Long
Public Declare Function cgGetEffectName Lib "vbCg20.dll" Alias "vb6_cgGetEffectName" (ByVal effect As Long) As Long
Public Declare Function cgGetNamedEffect Lib "vbCg20.dll" Alias "vb6_cgGetNamedEffect" (ByVal context As Long, ByVal name As String) As Long
Public Declare Function cgCreateEffectParameter Lib "vbCg20.dll" Alias "vb6_cgCreateEffectParameter" (ByVal effect As Long, ByVal name As String, ByVal t As Long) As Long

Public Declare Function cgCreateTechnique Lib "vbCg20.dll" Alias "vb6_cgCreateTechnique" (ByVal effect As Long, ByVal name As String) As Long

Public Declare Function cgCreateEffectParameterArray Lib "vbCg20.dll" Alias "vb6_cgCreateEffectParameterArray" (ByVal effect As Long, ByVal name As String, ByVal t As Long, ByVal length As Long) As Long
Public Declare Function cgCreateEffectParameterMultiDimArray Lib "vbCg20.dll" Alias "vb6_cgCreateEffectParameterMultiDimArray" (ByVal effect As Long, ByVal name As String, ByVal t As Long, ByVal d As Long, ByVal lengths As Long) As Long

Public Declare Function cgCreatePass Lib "vbCg20.dll" Alias "vb6_cgCreatePass" (ByVal technique As Long, ByVal name As String) As Long

Public Declare Function cgCreateStateAssignment Lib "vbCg20.dll" Alias "vb6_cgCreateStateAssignment" (ByVal pass As Long, ByVal state As Long) As Long
Public Declare Function cgCreateStateAssignmentIndex Lib "vbCg20.dll" Alias "vb6_cgCreateStateAssignmentIndex" (ByVal pass As Long, ByVal state As Long, ByVal index As Long) As Long
Public Declare Function cgCreateSamplerStateAssignment Lib "vbCg20.dll" Alias "vb6_cgCreateSamplerStateAssignment" (ByVal parameter As Long, ByVal state As Long) As Long

Public Declare Function cgSetFloatStateAssignment Lib "vbCg20.dll" Alias "vb6_cgSetFloatStateAssignment" (ByVal stateassignment As Long, ByVal f As Single) As Long
Public Declare Function cgSetIntStateAssignment Lib "vbCg20.dll" Alias "vb6_cgSetIntStateAssignment" (ByVal stateassignment As Long, ByVal i As Long) As Long
Public Declare Function cgSetBoolStateAssignment Lib "vbCg20.dll" Alias "vb6_cgSetBoolStateAssignment" (ByVal stateassignment As Long, ByVal b As Long) As Long
Public Declare Function cgSetStringStateAssignment Lib "vbCg20.dll" Alias "vb6_cgSetStringStateAssignment" (ByVal stateassignment As Long, ByVal s As String) As Long
Public Declare Function cgSetProgramStateAssignment Lib "vbCg20.dll" Alias "vb6_cgSetProgramStateAssignment" (ByVal stateassignment As Long, ByVal program As Long) As Long
Public Declare Function cgSetSamplerStateAssignment Lib "vbCg20.dll" Alias "vb6_cgSetSamplerStateAssignment" (ByVal stateassignment As Long, ByVal parameter As Long) As Long
Public Declare Function cgSetTextureStateAssignment Lib "vbCg20.dll" Alias "vb6_cgSetTextureStateAssignment" (ByVal stateassignment As Long, ByVal parameter As Long) As Long

Public Declare Function cgSetFloatArrayStateAssignment Lib "vbCg20.dll" Alias "vb6_cgSetFloatArrayStateAssignment" (ByVal stateassignment As Long, vals As Single) As Long
Public Declare Function cgSetIntArrayStateAssignment Lib "vbCg20.dll" Alias "vb6_cgSetIntArrayStateAssignment" (ByVal stateassignment As Long, vals As Long) As Long
Public Declare Function cgSetBoolArrayStateAssignment Lib "vbCg20.dll" Alias "vb6_cgSetBoolArrayStateAssignment" (ByVal stateassignment As Long, vals As Long) As Long

Public Declare Function cgCreateTechniqueAnnotation Lib "vbCg20.dll" Alias "vb6_cgCreateTechniqueAnnotation" (ByVal technique As Long, ByVal name As String, ByVal t As Long) As Long
Public Declare Function cgCreatePassAnnotation Lib "vbCg20.dll" Alias "vb6_cgCreatePassAnnotation" (ByVal pass As Long, ByVal name As String, ByVal t As Long) As Long
Public Declare Function cgCreateParameterAnnotation Lib "vbCg20.dll" Alias "vb6_cgCreateParameterAnnotation" (ByVal parameter As Long, ByVal name As String, ByVal t As Long) As Long
Public Declare Function cgCreateProgramAnnotation Lib "vbCg20.dll" Alias "vb6_cgCreateProgramAnnotation" (ByVal program As Long, ByVal name As String, ByVal t As Long) As Long
Public Declare Function cgCreateEffectAnnotation Lib "vbCg20.dll" Alias "vb6_cgCreateEffectAnnotation" (ByVal effect As Long, ByVal name As String, ByVal t As Long) As Long

Public Declare Function cgSetIntAnnotation Lib "vbCg20.dll" Alias "vb6_cgSetIntAnnotation" (ByVal annotation As Long, ByVal value As Long) As Long
Public Declare Function cgSetFloatAnnotation Lib "vbCg20.dll" Alias "vb6_cgSetFloatAnnotation" (ByVal annotation As Long, value As Single) As Long
Public Declare Function cgSetBoolAnnotation Lib "vbCg20.dll" Alias "vb6_cgSetBoolAnnotation" (ByVal annotation As Long, value As Long) As Long
Public Declare Function cgSetStringAnnotation Lib "vbCg20.dll" Alias "vb6_cgSetStringAnnotation" (ByVal annotation As Long, ByVal value As String) As Long

Public Declare Function cgGetStateEnumerantName Lib "vbCg20.dll" Alias "vb6_cgGetStateEnumerantName" (ByVal state As Long, ByVal value As Long) As Long
Public Declare Function cgGetStateEnumerantValue Lib "vbCg20.dll" Alias "vb6_cgGetStateEnumerantValue" (ByVal state As Long, ByVal name As String) As Long

Public Declare Function cgGetParameterEffect Lib "vbCg20.dll" Alias "vb6_cgGetParameterEffect" (ByVal param As Long) As Long

Public Declare Function cgGetTypeClass Lib "vbCg20.dll" Alias "vb6_cgGetTypeClass" (ByVal t As Long) As Long
Public Declare Function cgGetTypeBase Lib "vbCg20.dll" Alias "vb6_cgGetTypeBase" (ByVal t As Long) As Long
Public Declare Function cgGetTypeSizes Lib "vbCg20.dll" Alias "vb6_cgGetTypeSizes" (ByVal t As Long, ByVal nrows As Long, ByVal ncols As Long) As Long
Public Declare Sub cgGetMatrixSize Lib "vbCg20.dll" Alias "vb6_cgGetMatrixSize" (ByVal t As Long, ByVal nrows As Long, ByVal ncols As Long)

Public Declare Function cgGetNumProgramDomains Lib "vbCg20.dll" Alias "vb6_cgGetNumProgramDomains" (ByVal program As Long) As Long
Public Declare Function cgGetProfileDomain Lib "vbCg20.dll" Alias "vb6_cgGetProfileDomain" (ByVal profile As Long) As Long
Public Declare Function cgCombinePrograms Lib "vbCg20.dll" Alias "vb6_cgCombinePrograms" (ByVal n As Long, ByVal exeList As Long) As Long
Public Declare Function cgCombinePrograms2 Lib "vbCg20.dll" Alias "vb6_cgCombinePrograms2" (ByVal exe1 As Long, ByVal exe2 As Long) As Long
Public Declare Function cgCombinePrograms3 Lib "vbCg20.dll" Alias "vb6_cgCombinePrograms3" (ByVal exe1 As Long, ByVal exe2 As Long, ByVal exe3 As Long) As Long
Public Declare Function cgGetProgramDomainProfile Lib "vbCg20.dll" Alias "vb6_cgGetProgramDomainProfile" (ByVal program As Long, ByVal index As Long) As Long

' CGobj Functions
Public Declare Function cgCreateObj Lib "vbCg20.dll" Alias "vb6_cgCreateObj" (ByVal context As Long, ByVal program_type As Long, ByVal source As String, ByVal profile As Long, ByVal args As String) As Long
Public Declare Function cgCreateObjFromFile Lib "vbCg20.dll" Alias "vb6_cgCreateObjFromFile" (ByVal context As Long, ByVal program_type As Long, ByVal source_file As String, ByVal profile As Long, ByVal args As String) As Long
Public Declare Sub cgDestroyObj Lib "vbCg20.dll" Alias "vb6_cgDestroyObj" (ByVal obj As Long)

Public Declare Function cgGetParameterResourceSize Lib "vbCg20.dll" Alias "vb6_cgGetParameterResourceSize" (ByVal parameter As Long) As Long
Public Declare Function cgGetParameterResourceType Lib "vbCg20.dll" Alias "vb6_cgGetParameterResourceType" (ByVal parameter As Long) As Long
Public Declare Function cgGetParameterBufferIndex Lib "vbCg20.dll" Alias "vb6_cgGetParameterBufferIndex" (ByVal parameter As Long) As Long
Public Declare Function cgGetParameterBufferOffset Lib "vbCg20.dll" Alias "vb6_cgGetParameterBufferOffset" (ByVal parameter As Long) As Long

Public Declare Function cgCreateBuffer Lib "vbCg20.dll" Alias "vb6_cgCreateBuffer" (ByVal context As Long, ByVal size As Long, ByVal data As Long, ByVal bufferUsage As Long) As Long
Public Declare Sub cgSetBufferData Lib "vbCg20.dll" Alias "vb6_cgSetBufferData" (ByVal buffer As Long, ByVal size As Long, ByVal data As Long)
Public Declare Sub cgSetBufferSubData Lib "vbCg20.dll" Alias "vb6_cgSetBufferSubData" (ByVal buffer As Long, ByVal offset As Long, ByVal size As Long, ByVal data As Long)
Public Declare Sub cgSetProgramBuffer Lib "vbCg20.dll" Alias "vb6_cgSetProgramBuffer" (ByVal program As Long, ByVal bufferIndex As Long, ByVal buffer As Long)

Public Declare Sub cgMapBuffer Lib "vbCg20.dll" Alias "vb6_cgMapBuffer" (ByVal buffer As Long, ByVal access As Long)
Public Declare Sub cgUnmapBuffer Lib "vbCg20.dll" Alias "vb6_cgUnmapBuffer" (ByVal buffer As Long)
Public Declare Sub cgDestroyBuffer Lib "vbCg20.dll" Alias "vb6_cgDestroyBuffer" (ByVal buffer As Long)
Public Declare Function cgGetProgramBuffer Lib "vbCg20.dll" Alias "vb6_cgGetProgramBuffer" (ByVal program As Long, ByVal bufferIndex As Long) As Long
Public Declare Function cgGetBufferSize Lib "vbCg20.dll" Alias "vb6_cgGetBufferSize" (ByVal buffer As Long) As Long
Public Declare Function cgGetProgramBufferMaxSize Lib "vbCg20.dll" Alias "vb6_cgGetProgramBufferMaxSize" (ByVal profile As Long) As Long
Public Declare Function cgGetProgramBufferMaxIndex Lib "vbCg20.dll" Alias "vb6_cgGetProgramBufferMaxIndex" (ByVal profile As Long) As Long

' Profile Functions
Public Declare Function cgGLIsProfileSupported Lib "vbCg20.dll" Alias "vb6_cgGLIsProfileSupported" (ByVal profile As Long) As Long
Public Declare Sub cgGLEnableProfile Lib "vbCg20.dll" Alias "vb6_cgGLEnableProfile" (ByVal profile As Long)
Public Declare Sub cgGLDisableProfile Lib "vbCg20.dll" Alias "vb6_cgGLDisableProfile" (ByVal profile As Long)
Public Declare Function cgGLGetLatestProfile Lib "vbCg20.dll" Alias "vb6_cgGLGetLatestProfile" (ByVal profile_type As Long) As Long
Public Declare Sub cgGLSetOptimalOptions Lib "vbCg20.dll" Alias "vb6_cgGLSetOptimalOptions" (ByVal profile As Long)

' Program Managment Functions
Public Declare Sub cgGLLoadProgram Lib "vbCg20.dll" Alias "vb6_cgGLLoadProgram" (ByVal program As Long)
Public Declare Function cgGLIsProgramLoaded Lib "vbCg20.dll" Alias "vb6_cgGLIsProgramLoaded" (ByVal program As Long) As Boolean
Public Declare Sub cgGLBindProgram Lib "vbCg20.dll" Alias "vb6_cgGLBindProgram" (ByVal program As Long)
Public Declare Sub cgGLUnbindProgram Lib "vbCg20.dll" Alias "vb6_cgGLUnbindProgram" (ByVal profile As Long)
Public Declare Function cgGLGetProgramID Lib "vbCg20.dll" Alias "vb6_cgGLGetProgramID" (ByVal program As Long) As Long

' Parameter Management Functions
Public Declare Sub cgGLSetParameter1f Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter1f" (ByVal param As Long, ByVal x As Single)
Public Declare Sub cgGLSetParameter2f Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter2f" (ByVal param As Long, ByVal x As Single, ByVal y As Single)
Public Declare Sub cgGLSetParameter3f Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter3f" (ByVal param As Long, ByVal x As Single, ByVal y As Single, ByVal z As Single)
Public Declare Sub cgGLSetParameter4f Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter4f" (ByVal param As Long, ByVal x As Single, ByVal y As Single, ByVal z As Single, ByVal w As Single)
Public Declare Sub cgGLSetParameter1fv Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter1fv" (ByVal param As Long, v As Single)
Public Declare Sub cgGLSetParameter2fv Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter2fv" (ByVal param As Long, v As Single)
Public Declare Sub cgGLSetParameter3fv Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter3fv" (ByVal param As Long, v As Single)
Public Declare Sub cgGLSetParameter4fv Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter4fv" (ByVal param As Long, v As Single)
Public Declare Sub cgGLSetParameter1d Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter1d" (ByVal param As Long, ByVal x As Double)
Public Declare Sub cgGLSetParameter2d Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter2d" (ByVal param As Long, ByVal x As Double, ByVal y As Double)
Public Declare Sub cgGLSetParameter3d Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter3d" (ByVal param As Long, ByVal x As Double, ByVal y As Double, ByVal z As Double)
Public Declare Sub cgGLSetParameter4d Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter4d" (ByVal param As Long, ByVal x As Double, ByVal y As Double, ByVal z As Double, ByVal w As Double)
Public Declare Sub cgGLSetParameter1dv Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter1dv" (ByVal param As Long, v As Double)
Public Declare Sub cgGLSetParameter2dv Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter2dv" (ByVal param As Long, v As Double)
Public Declare Sub cgGLSetParameter3dv Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter3dv" (ByVal param As Long, v As Double)
Public Declare Sub cgGLSetParameter4dv Lib "vbCg20.dll" Alias "vb6_cgGLSetParameter4dv" (ByVal param As Long, v As Double)
Public Declare Sub cgGLGetParameter1f Lib "vbCg20.dll" Alias "vb6_cgGLGetParameter1f" (ByVal param As Long, ByVal x As Single)
Public Declare Sub cgGLGetParameter2f Lib "vbCg20.dll" Alias "vb6_cgGLGetParameter2f" (ByVal param As Long, ByVal x As Single, ByVal y As Single)
Public Declare Sub cgGLGetParameter3f Lib "vbCg20.dll" Alias "vb6_cgGLGetParameter3f" (ByVal param As Long, ByVal x As Single, ByVal y As Single, ByVal z As Single)
Public Declare Sub cgGLGetParameter4f Lib "vbCg20.dll" Alias "vb6_cgGLGetParameter4f" (ByVal param As Long, ByVal x As Single, ByVal y As Single, ByVal z As Single, ByVal w As Single)
Public Declare Sub cgGLGetParameter1d Lib "vbCg20.dll" Alias "vb6_cgGLGetParameter1d" (ByVal param As Long, ByVal x As Double)
Public Declare Sub cgGLGetParameter2d Lib "vbCg20.dll" Alias "vb6_cgGLGetParameter2d" (ByVal param As Long, ByVal x As Double, ByVal y As Double)
Public Declare Sub cgGLGetParameter3d Lib "vbCg20.dll" Alias "vb6_cgGLGetParameter3d" (ByVal param As Long, ByVal x As Double, ByVal y As Double, ByVal z As Double)
Public Declare Sub cgGLGetParameter4d Lib "vbCg20.dll" Alias "vb6_cgGLGetParameter4d" (ByVal param As Long, ByVal x As Double, ByVal y As Double, ByVal z As Double, ByVal w As Double)
Public Declare Sub cgGLSetParameterArray1f Lib "vbCg20.dll" Alias "vb6_cgGLSetParameterArray1f" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Single)
Public Declare Sub cgGLSetParameterArray2f Lib "vbCg20.dll" Alias "vb6_cgGLSetParameterArray2f" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Single)
Public Declare Sub cgGLSetParameterArray3f Lib "vbCg20.dll" Alias "vb6_cgGLSetParameterArray3f" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Single)
Public Declare Sub cgGLSetParameterArray4f Lib "vbCg20.dll" Alias "vb6_cgGLSetParameterArray4f" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Single)
Public Declare Sub cgGLSetParameterArray1d Lib "vbCg20.dll" Alias "vb6_cgGLSetParameterArray1d" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Double)
Public Declare Sub cgGLSetParameterArray2d Lib "vbCg20.dll" Alias "vb6_cgGLSetParameterArray2d" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Double)
Public Declare Sub cgGLSetParameterArray3d Lib "vbCg20.dll" Alias "vb6_cgGLSetParameterArray3d" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Double)
Public Declare Sub cgGLSetParameterArray4d Lib "vbCg20.dll" Alias "vb6_cgGLSetParameterArray4d" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Double)
Public Declare Sub cgGLGetParameterArray1f Lib "vbCg20.dll" Alias "vb6_cgGLGetParameterArray1f" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Single)
Public Declare Sub cgGLGetParameterArray2f Lib "vbCg20.dll" Alias "vb6_cgGLGetParameterArray2f" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Single)
Public Declare Sub cgGLGetParameterArray3f Lib "vbCg20.dll" Alias "vb6_cgGLGetParameterArray3f" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Single)
Public Declare Sub cgGLGetParameterArray4f Lib "vbCg20.dll" Alias "vb6_cgGLGetParameterArray4f" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Single)
Public Declare Sub cgGLGetParameterArray1d Lib "vbCg20.dll" Alias "vb6_cgGLGetParameterArray1d" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Double)
Public Declare Sub cgGLGetParameterArray2d Lib "vbCg20.dll" Alias "vb6_cgGLGetParameterArray2d" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Double)
Public Declare Sub cgGLGetParameterArray3d Lib "vbCg20.dll" Alias "vb6_cgGLGetParameterArray3d" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Double)
Public Declare Sub cgGLGetParameterArray4d Lib "vbCg20.dll" Alias "vb6_cgGLGetParameterArray4d" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, v As Double)
Public Declare Sub cgGLSetParameterPointer Lib "vbCg20.dll" Alias "vb6_cgGLSetParameterPointer" (ByVal param As Long, ByVal fsize As Long, ByVal t As Long, ByVal stride As Long, ByVal pointer As Long)
Public Declare Sub cgGLEnableClientState Lib "vbCg20.dll" Alias "vb6_cgGLEnableClientState" (ByVal param As Long)
Public Declare Sub cgGLDisableClientState Lib "vbCg20.dll" Alias "vb6_cgGLDisableClientState" (ByVal param As Long)

' Matrix Parameter Managment Functions
Public Declare Sub cgGLSetMatrixParameterdr Lib "vbCg20.dll" Alias "vb6_cgGLSetMatrixParameterdr" (ByVal param As Long, Matrix As Double)
Public Declare Sub cgGLSetMatrixParameterfr Lib "vbCg20.dll" Alias "vb6_cgGLSetMatrixParameterfr" (ByVal param As Long, Matrix As Single)
Public Declare Sub cgGLSetMatrixParameterdc Lib "vbCg20.dll" Alias "vb6_cgGLSetMatrixParameterdc" (ByVal param As Long, Matrix As Double)
Public Declare Sub cgGLSetMatrixParameterfc Lib "vbCg20.dll" Alias "vb6_cgGLSetMatrixParameterfc" (ByVal param As Long, Matrix As Single)
Public Declare Sub cgGLGetMatrixParameterdr Lib "vbCg20.dll" Alias "vb6_cgGLGetMatrixParameterdr" (ByVal param As Long, Matrix As Double)
Public Declare Sub cgGLGetMatrixParameterfr Lib "vbCg20.dll" Alias "vb6_cgGLGetMatrixParameterfr" (ByVal param As Long, Matrix As Single)
Public Declare Sub cgGLGetMatrixParameterdc Lib "vbCg20.dll" Alias "vb6_cgGLGetMatrixParameterdc" (ByVal param As Long, Matrix As Double)
Public Declare Sub cgGLGetMatrixParameterfc Lib "vbCg20.dll" Alias "vb6_cgGLGetMatrixParameterfc" (ByVal param As Long, Matrix As Single)
Public Declare Sub cgGLSetStateMatrixParameter Lib "vbCg20.dll" Alias "vb6_cgGLSetStateMatrixParameter" (ByVal param As Long, ByVal Matrix As Long, ByVal transform As Long)
Public Declare Sub cgGLSetMatrixParameterArrayfc Lib "vbCg20.dll" Alias "vb6_cgGLSetMatrixParameterArrayfc" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Single)
Public Declare Sub cgGLSetMatrixParameterArrayfr Lib "vbCg20.dll" Alias "vb6_cgGLSetMatrixParameterArrayfr" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Single)
Public Declare Sub cgGLSetMatrixParameterArraydc Lib "vbCg20.dll" Alias "vb6_cgGLSetMatrixParameterArraydc" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Double)
Public Declare Sub cgGLSetMatrixParameterArraydr Lib "vbCg20.dll" Alias "vb6_cgGLSetMatrixParameterArraydr" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Double)
Public Declare Sub cgGLGetMatrixParameterArrayfc Lib "vbCg20.dll" Alias "vb6_cgGLGetMatrixParameterArrayfc" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Single)
Public Declare Sub cgGLGetMatrixParameterArrayfr Lib "vbCg20.dll" Alias "vb6_cgGLGetMatrixParameterArrayfr" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Single)
Public Declare Sub cgGLGetMatrixParameterArraydc Lib "vbCg20.dll" Alias "vb6_cgGLGetMatrixParameterArraydc" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Double)
Public Declare Sub cgGLGetMatrixParameterArraydr Lib "vbCg20.dll" Alias "vb6_cgGLGetMatrixParameterArraydr" (ByVal param As Long, ByVal offset As Long, ByVal nelements As Long, matrices As Double)

' Texture Parameter Managment Functions
Public Declare Sub cgGLSetTextureParameter Lib "vbCg20.dll" Alias "vb6_cgGLSetTextureParameter" (ByVal param As Long, ByVal texobj As Long)
Public Declare Function cgGLGetTextureParameter Lib "vbCg20.dll" Alias "vb6_cgGLGetTextureParameter" (ByVal param As Long) As Long
Public Declare Sub cgGLEnableTextureParameter Lib "vbCg20.dll" Alias "vb6_cgGLEnableTextureParameter" (ByVal param As Long)
Public Declare Sub cgGLDisableTextureParameter Lib "vbCg20.dll" Alias "vb6_cgGLDisableTextureParameter" (ByVal param As Long)
Public Declare Sub cgGLGetTextureEnum Lib "vbCg20.dll" Alias "vb6_cgGLGetTextureEnum" (ByVal param As Long)
Public Declare Sub cgGLSetManageTextureParameters Lib "vbCg20.dll" Alias "vb6_cgGLSetManageTextureParameters" (ByVal ctx As Long, ByVal flag As Long)
Public Declare Function cgGLGetManageTextureParameters Lib "vbCg20.dll" Alias "vb6_cgGLGetManageTextureParameters" (ByVal ctx As Long) As Long
Public Declare Sub cgGLSetupSampler Lib "vbCg20.dll" Alias "vb6_cgGLSetupSampler" (ByVal param As Long, ByVal texobj As Long)
Public Declare Sub cgGLRegisterStates Lib "vbCg20.dll" Alias "vb6_cgGLRegisterStates" (ByVal ctx As Long)
Public Declare Sub cgGLEnableProgramProfiles Lib "vbCg20.dll" Alias "vb6_cgGLEnableProgramProfiles" (ByVal program As Long)
Public Declare Sub cgGLDisableProgramProfiles Lib "vbCg20.dll" Alias "vb6_cgGLDisableProgramProfiles" (ByVal program As Long)

' Misc Functions
Public Declare Sub cgGLSetDebugMode Lib "vbCg20.dll" Alias "vb6_cgGLSetDebugMode" (ByVal dbg As Long)

' Buffer Functions
Public Declare Function cgGLCreateBuffer Lib "vbCg20.dll" Alias "vb6_cgGLCreateBuffer" (ByVal context As Long, ByVal size As Long, ByVal data As Long, ByVal bufferUsage As Long) As Long
Public Declare Function cgGLGetBufferObject Lib "vbCg20.dll" Alias "vb6_cgGLGetBufferObject" (ByVal buffer As Long) As Long

Public Function GetCgErrorDescription(errorNum As Long) As String
    Select Case errorNum
           Case 0
                GetCgErrorDescription = "No error has occurred."
           Case 1
                GetCgErrorDescription = "The compile returned an error."
           Case 2
                GetCgErrorDescription = "The parameter used is invalid."
           Case 3
                GetCgErrorDescription = "The profile is not supported."
           Case 4
                GetCgErrorDescription = "The program could not load."
           Case 5
                GetCgErrorDescription = "The program could not bind."
           Case 6
                GetCgErrorDescription = "The program must be loaded before this operation may be used."
           Case 7
                GetCgErrorDescription = "An unsupported GL extension was required to perform this operation."
           Case 8
                GetCgErrorDescription = "An unknown value type was assigned to a parameter."
           Case 9
                GetCgErrorDescription = "The parameter is not of matrix type."
           Case 10
                GetCgErrorDescription = "The enumerant parameter has an invalid value."
           Case 11
                GetCgErrorDescription = "The parameter must be a 4x4 matrix type."
           Case 12
                GetCgErrorDescription = "The file could not be read."
           Case 13
                GetCgErrorDescription = "The file could not be written."
           Case 14
                GetCgErrorDescription = "nvparse could not successfully parse the output from the Cg compiler backend."
           Case 15
                GetCgErrorDescription = "Memory allocation failed."
           Case 16
                GetCgErrorDescription = "Invalid context handle."
           Case 17
                GetCgErrorDescription = "Invalid program handle."
           Case 18
                GetCgErrorDescription = "Invalid parameter handle."
           Case 19
                GetCgErrorDescription = "The specified profile is unknown."
           Case 20
                GetCgErrorDescription = "The variable arguments were specified incorrectly."
           Case 21
                GetCgErrorDescription = "The dimension value is invalid."
           Case 22
                GetCgErrorDescription = "The parameter must be an array."
           Case 23
                GetCgErrorDescription = "Index into the array is out of bounds."
           Case 24
                GetCgErrorDescription = "A type being added to the context conflicts with an existing type."
           Case 25
                GetCgErrorDescription = "The parameters being bound have conflicting types."
           Case 26
                GetCgErrorDescription = "The parameter must be global."
           Case 27
                GetCgErrorDescription = "The parameter could not be changed to the given variability."
           Case 28
                GetCgErrorDescription = "Cannot destroy the parameter.  It is bound to other parameters or is not a root parameter."
           Case 29
                GetCgErrorDescription = "The parameter is not a root parameter."
           Case 30
                GetCgErrorDescription = "The two parameters being bound do not match."
           Case 31
                GetCgErrorDescription = "The parameter is not a program parameter."
           Case 32
                GetCgErrorDescription = "The type of the parameter is invalid."
           Case 33
                GetCgErrorDescription = "The parameter must be a resizable array."
           Case 34
                GetCgErrorDescription = "The size value is invalid."
           Case 35
                GetCgErrorDescription = "Cannot bind the given parameters.  Binding will form a cycle."
           Case 36
                GetCgErrorDescription = "Cannot bind the given parameters.  Array types do not match."
           Case 37
                GetCgErrorDescription = "Cannot bind the given parameters. Array dimensions do not match."
           Case 38
                GetCgErrorDescription = "The array has the wrong dimension."
           Case 39
                GetCgErrorDescription = "Connecting the parameters failed because The type of the source parameter is not defined within the given program or does not match the type with the same name in the program."
           Case 40
                GetCgErrorDescription = "Invalid effect handle."
           Case 41
                GetCgErrorDescription = "Invalid state handle."
           Case 42
                GetCgErrorDescription = "Invalid stateassignment handle."
           Case 43
                GetCgErrorDescription = "Invalid pass handle."
           Case 44
                GetCgErrorDescription = "Invalid annotation handle."
           Case 45
                GetCgErrorDescription = "Invalid technique handle."
           Case 46
                GetCgErrorDescription = "Invalid parameter handle."
           Case 47
                GetCgErrorDescription = "Operation is not valid for this type of stateassignment."
           Case 48
                GetCgErrorDescription = "Invalid function handle."
           Case 49
                GetCgErrorDescription = "Technique did not pass validation."
           Case 50
                GetCgErrorDescription = "The supplied pointer is NULL."
           Case 51
                GetCgErrorDescription = "Not enough data was provided."
           Case 52
                GetCgErrorDescription = "The parameter is not of a numeric type."
           Case 53
                GetCgErrorDescription = "The specified array sizes are not compatible with the given array."
           Case 54
                GetCgErrorDescription = "Cannot set the value of a non-uniform parameter."
           Case 55
                GetCgErrorDescription = "This name is already in use."

    End Select
End Function

Public Function ScanText(ptr As Long) As String
    Dim strTmp As String
    Dim bytTmp As Byte
    Dim lngIdx As Long
    lngIdx = 0
    Do
       CopyMemory bytTmp, ByVal ptr + lngIdx, 1
       If Chr(bytTmp) = vbNullChar _
          Then
              Exit Do
          Else
              strTmp = strTmp & Chr(bytTmp)
              lngIdx = lngIdx + 1
       End If
    Loop
    ScanText = strTmp
End Function

Public Function CGstatecallback(ByVal stateassignment As Long) As Long
End Function

Public Sub CGerrorCallbackFunc()
End Sub

Public Sub CGerrorHandlerFunc(ByVal ctx As Long, ByVal err As Long, ByVal data As Long)
End Sub


